var flattening = function (arr) {
  var newArr = []
  var len = arr.length
  var hasArray = false
  for (var i = 0; i < len; i++) {
    var item = arr[i]
    if (Array.isArray(item)) {
      newArr = newArr.concat(item)
      hasArray = true
    } else {
      newArr.push(item)
    }
  }
  if (!hasArray) return newArr
  return flattening(newArr)
}

var findIndex = function (arr, key) {
  for (var i = 0; i < arr.length; i++) {
    if (arr[i] === key) return i
  }
  return false
}

var isFunction = function (v) {
  return typeof v === 'function'
}

function Emiter () {
  this.$events = {}
}

Emiter.prototype.on = function (type, handler) {
  if (!isFunction(handler)) {
    throw new Error('The handler of the event of ' + type + ' is not a function')
  }

  var $events = this.$events;
  ($events[type] || ($events[type] = [])).push(handler)
}

// only once subscribe event
Emiter.prototype.once = function (type, handler) {
  var that = this

  function on () {
    that.off(type, on)
    handler.apply(null, arguments)
  }

  this.on(type, on)
}

// remove event
Emiter.prototype.off = function (type, handler) {
  // all
  if (!type) {
    this.$events = {}
    return
  }

  var queue = this.$events[type]

  // without event queue
  if (!queue) return

  // specity event to clear queue
  if (!handler) {
    this.$events[type] = []
    return
  }

  // specity handler
  var cbs = queue
  var loop = queue.length
  var cb
  while (loop--) {
    cb = cbs[loop]
    if (cb === handler) {
      cbs.splice(loop, 1)
      break
    }
  }
}

// global flag, to mark down current event type when event emit
var eventType

// emit event
Emiter.prototype.emit = function () {
  var type = eventType = arguments[0]
  var queue = this.$events[type]

  if (Array.isArray(queue) && queue.length) {
    var loop = 0
    var item
    var args = [].slice.call(arguments, 1)

    while (item = queue[loop++]) {
      item.apply(this, args)
    }
  }
}

// event queue listen
Emiter.prototype.all = function (eventQueue, success) {
  if (!Array.isArray(eventQueue) || !isFunction(success)) return
  var len = eventQueue.length
  var argsCollection = []

  var consume = function () {
    // use the global eventType to match type
    // and return index from eventQueue
    var index = findIndex(eventQueue, eventType)

    if (index !== false) {
      var ArgsArray = [].slice.call(arguments)
      // base on corresponding index from eventQueue,
      // mapping the collection of callback arguments
      argsCollection[index] = ArgsArray
    }

    // when len is zero mean that
    // the queue of all event executed completely
    --len || success(flattening(argsCollection))
  }

  if (len) {
    var i = 0
    var key
    while (key = eventQueue[i++]) {
      this.once(key, consume)
    }
  }
}

export default Emiter
